//+------------------------------------------------------------------+
//|                                                    V_5.mq4 |
//|                      Copyright  2008, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, MetaQuotes Software Corp."
#property link      "http://www.MQL-Advisor.ru"

extern double Lot=0.5;
extern int    Min_Dist=70;
extern double Pribyl=300;
extern double K_Martin=2;

int r,ret,Dist;
double STDEV;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
STDEV=0;
HideTestIndicators(true);
for (int D=0;D<=24*3;D++)
{
STDEV=STDEV+iStdDev(NULL,0,13,0,MODE_EMA,PRICE_CLOSE,D);
}
Dist=(MathAbs((STDEV/(24*3))/Point))*2;
if (Dist<Min_Dist)     Dist=Min_Dist;   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
Comment("");   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
int B=0,S=0,BS=0,SS=0;
double Prof=0,L_B=0,L_S=0,Lev_B,Lev_S;  
//--------------    --------------------------------------------      
          for( r=0;r<OrdersTotal();r++) //  
      {
      if(OrderSelect(r,SELECT_BY_POS,MODE_TRADES)==false)    continue;
      if(OrderSymbol()==Symbol())
      {
      if (OrderType()==OP_BUY )        {  B++;Prof=Prof+OrderProfit()+OrderSwap();L_B=L_B+OrderLots();Lev_B=OrderOpenPrice();}
      if (OrderType()==OP_SELL )       {  S++;Prof=Prof+OrderProfit()+OrderSwap();L_S=L_S+OrderLots();Lev_S=OrderOpenPrice();}

      if (OrderType()==OP_BUYSTOP )   BS++;
      if (OrderType()==OP_SELLSTOP)   SS++;
      }}
//---------  -----------------------------
Comment("  ",Prof,"   Dist  ",Dist);      
      
//-------    ------------------------
if (B+S==0)
{
// ---------  ST_Dev -------------------------
STDEV=0;
HideTestIndicators(true);
for (int D=0;D<=24*3;D++)
{
STDEV=STDEV+iStdDev(NULL,0,13,0,MODE_EMA,PRICE_CLOSE,D);
}
Dist=(MathAbs((STDEV/(24*3))/Point))*2;
if (Dist<Min_Dist)     Dist=Min_Dist;
double MA1=iMA(NULL,PERIOD_H1,6,0,MODE_SMA,PRICE_CLOSE,1);
double MA0=iMA(NULL,PERIOD_H1,6,0,MODE_SMA,PRICE_CLOSE,0);
if (MA0>MA1)
{
ret= OrderSend(Symbol(),OP_BUY,Lot,Ask,0,0,0,"",0,0,Blue);
return(0);     
}
if (MA1>MA0)
{
ret= OrderSend(Symbol(),OP_SELL,Lot,Bid,0,0,0,"",0,0,Red);
return(0);     
}
}
//---------       ------------------
if (B>0 && S==0) Lev_S=Lev_B-Dist*Point;
if (B==0 && S>0) Lev_B=Lev_S+Dist*Point;
//---------     -------------------------
if (L_B>L_S && SS==0) // --   BUY   SELL
{
ret=OrderSend(Symbol(),OP_SELLSTOP,NormalizeDouble(L_B*K_Martin-L_S,2),Lev_S,3,0,0,"",0,0,CLR_NONE);
return(0);
}
if (L_S>L_B && BS==0) // --   SELL   BUY
{
ret=OrderSend(Symbol(),OP_BUYSTOP,NormalizeDouble(L_S*K_Martin-L_B,2),Lev_B,3,0,0,"",0,0,CLR_NONE);
return(0);
}
if (Prof>=Pribyl) CloseALL();
   return(0);
  }
//+------------------------------------------------------------------+
//----------------   -----------------------------------------
int Ord_Tot_Sym()
{
int O_T=0;
      for(int rr=0;rr<OrdersTotal();rr++) //  
      {
      if(OrderSelect(rr,SELECT_BY_POS,MODE_TRADES)==false)    continue;
      if(OrderSymbol()==Symbol())
      {
   O_T++;    
      }}
      if (O_T>0) return(1);
      else return(0);
}
    

//-------------- CloseAll --------------------------   
int CloseALL()
{
int ic;
 while (Ord_Tot_Sym()>0) 
 {
 RefreshRates();
                  for(ic=OrdersTotal()-1;ic>=0;ic--)
                   {
                  if(OrderSelect(ic,SELECT_BY_POS,MODE_TRADES)==false) continue;
                  if (OrderSymbol()==Symbol())
                  {
                  if (OrderType()==OP_BUY)
                  {
                  //RefreshRates();
                  ret=OrderClose(OrderTicket(),OrderLots(),Bid,0,CLR_NONE);
                  if (IsTradeAllowed()) continue;
                  else Sleep(1000);
                  }
                                    
                  if (OrderType()==OP_SELL)
                  {
                  //RefreshRates();
                  ret=OrderClose(OrderTicket(),OrderLots(),Ask,0,CLR_NONE);
                  if (IsTradeAllowed()) continue;
                  else Sleep(1000);
                  }}}
//---------        ------------------------                    
                  for(ic=OrdersTotal()-1;ic>=0;ic--)
                   {
                  if(OrderSelect(ic,SELECT_BY_POS,MODE_TRADES)==false) continue;
                  if (OrderSymbol()==Symbol())
                  {
                  if (OrderType()==OP_BUYSTOP || OrderType()==OP_SELLSTOP ||
                     OrderType()==OP_BUYLIMIT || OrderType()==OP_SELLLIMIT)
                  ret=OrderDelete(OrderTicket());
                  }}
      PlaySound("MsgBell.wav" );
      }
   return(0);
  }